package org.processmining.mixedparadigm.algorithms.replayer;

import org.processmining.plugins.astar.petrinet.impl.AbstractPILPDelegate;
import org.processmining.plugins.astar.petrinet.impl.PHead;
import org.processmining.plugins.astar.petrinet.impl.PILPTail;

import nl.tue.astar.AStarThread;
import nl.tue.astar.Delegate;
import nl.tue.astar.Head;
import nl.tue.astar.Tail;

public class PAutomataTail extends PILPTail {

	protected PAutomataTail(int estimate, short[] variables, boolean isExact) {
		super(estimate, variables, isExact);
		// TODO Auto-generated constructor stub
	}

	public PAutomataTail(AbstractPILPDelegate<?> delegate, PHead h, int minCost) {
		super(delegate, h, minCost);
		// TODO Auto-generated constructor stub
	}

	@Override
	public PAutomataTail getNextTail(Delegate<? extends Head, ? extends Tail> d, Head newHead, int modelMove,
			int logMove, int activity) {
		if (modelMove != AStarThread.NOMOVE && modelMove < 0) {
			modelMove = -modelMove - 1;
		}
		PILPDelegateAutomata delegate = ((PILPDelegateAutomata) d);

		int newEst = estimate - delegate.getCostFor(modelMove, activity);

		// check if the is move was allowed according to the LP:
		if (modelMove == AStarThread.NOMOVE) {
			// logMove only. The variable is at location 2*delegate.numTransitions() + activity
			int var = 2 * delegate.numTransitions() + activity;
			if (variables[var] >= 1) {
				// move was allowed according to LP.
				short[] newVars = new short[variables.length];
				System.arraycopy(variables, 0, newVars, 0, variables.length);
				newVars[var] -= 1;
				return new PAutomataTail(newEst, newVars, true);
			}
		} else if (logMove == AStarThread.NOMOVE) {
			// there was a modelMove only, determine the newly enabled moves.
			int var = modelMove;

			if (variables[var] >= 1 && !delegate.hasResetArc(modelMove)) {
				// move was allowed according to LP.
				short[] newVars = new short[variables.length];
				System.arraycopy(variables, 0, newVars, 0, variables.length);
				newVars[var] -= 1;
				return new PAutomataTail(newEst, newVars, true);
			}

		} else {
			// Synchronous move. The variable is at location delegate.numTransitions() + modelMove
			int var = delegate.numTransitions() + modelMove;
			if (variables[var] >= 1 && !delegate.hasResetArc(modelMove)) {
				// move was allowed according to LP.
				short[] newVars = new short[variables.length];
				System.arraycopy(variables, 0, newVars, 0, variables.length);
				newVars[var] -= 1;
				return new PAutomataTail(newEst, newVars, true);
			}
		}
		//BVD: DO NOT use newEst maximized with size of Parikh Vector as this violates the monotonicity
		return new PAutomataTail(delegate, (PHead) newHead, newEst);//Math.max(newEst, ((PHead) newHead).getParikhVector().getNumElts()));
	}

}
