package org.processmining.mixedparadigm.dialogs;

import javax.swing.JComponent;
import javax.swing.JLabel;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.widgets.ProMComboBox;
import org.processmining.framework.util.ui.widgets.ProMPasswordField;
import org.processmining.framework.util.ui.widgets.ProMTextField;
import org.processmining.mixedparadigm.parameters.DatabaseDeclareParameters;
import org.processmining.widgets.wizard.AbstractDialog;
import org.processmining.widgets.wizard.Dialog;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class ConfigurationDialogImpl extends AbstractDialog<DatabaseDeclareParameters> {
	
	private static final long serialVersionUID = 1L;
	private final ProMTextField username;
	private final ProMPasswordField password;
	private final ProMTextField server;
	private final ProMTextField databaseName;
	private final ProMTextField logId;
	private final ProMComboBox<Object> createIS;

	public ConfigurationDialogImpl(UIPluginContext context, String title,
			DatabaseDeclareParameters parameters,
			Dialog<DatabaseDeclareParameters> previous) {
		
		super(context, title, parameters, previous);
		username = new ProMTextField(parameters.getUsername(), 	"Enter your database username");
		password = new ProMPasswordField(parameters.getPassword());
		server = new ProMTextField(parameters.getServer(), 	"Enter your server");
		databaseName = new ProMTextField(parameters.getDatabaseName(), 	"Enter your database name");
		logId = new ProMTextField(parameters.getLogId(), 	"Enter your log identifier");
		createIS = new ProMComboBox<Object>(new String[]{"No","Yes"});
	}
	
	private void addUsernameParameter() {
		JLabel label = SlickerFactory.instance().createLabel("Username:");
		add(label);
		add(username);
	}
	
	private void addPasswordParameter() {
		JLabel label = SlickerFactory.instance().createLabel("Password:");
		add(label);
		add(password);
	}
	
	private void addServerParameter() {
		JLabel label = SlickerFactory.instance().createLabel("Server:");
		add(label);
		add(server);
	}
	
	private void addDatabaseNameParameter() {
		JLabel label = SlickerFactory.instance().createLabel("Database name:");
		add(label);
		add(databaseName);
	}
	
	private void addLogIdParameter() {
		JLabel label = SlickerFactory.instance().createLabel("Log identifier:");
		add(label);
		add(logId);
	}
	
	private void addCreateISParameter() {
		JLabel label = SlickerFactory.instance().createLabel("Create Intermediate Structures:");
		add(label);
		add(createIS);
	}
	
	public boolean hasNextDialog() {
		return false;
	}

	public void updateParametersOnGetNext() {
		getParameters().setUsername(username.getText());
		getParameters().setPassword(password.getText());
		getParameters().setServer(server.getText());
		getParameters().setDatabaseName(databaseName.getText());
		getParameters().setLogId(logId.getText());
		if(createIS.getSelectedIndex() == 0) {
			getParameters().setCreateIS(false);
		} else {
			getParameters().setCreateIS(true);
		}
	}

	public void updateParametersOnGetPrevious() {
		updateParametersOnGetNext();
		
	}

	public JComponent visualize() {
		removeAll();
		addUsernameParameter();
		addPasswordParameter();
		addServerParameter();
		addDatabaseNameParameter();
		addLogIdParameter();
		addCreateISParameter();
		revalidate();
		repaint();
		return this;
	}

	protected boolean canProceedToNext() {
		return true;
		//return username.getText().length() != 0 && password.getText().length() != 0 && server.getText().length() != 0  && databaseName.getText().length() != 0 && logId.getText().length() != 0;
	}

	protected Dialog<DatabaseDeclareParameters> determineNextDialog() {
			return null;
	}

	protected String getUserInputProblems() {
		// TODO Auto-generated method stub
		return null;
	}

}
