package org.processmining.mixedparadigm.models.dfa.choice;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class Exclusive1ofM extends GeneralDeterministicFiniteAutomaton {

	public Exclusive1ofM(int alphabetSize, short... transM) {
		super("1 of " + transM.length, alphabetSize, transM.length + 1);

		// add two state
		short s0 = addState(true, TV, true);
		for (short m = 0; m < transM.length; m++) {
			short sm = addState(false, PS, true);
			addTransition(s0, sm, m);
			for (short n : transM) {
				// cannot do anything from transM
				removeTransition(sm, n);
			}
			// except m
			addTransition(sm, sm, m);

		}
	}

}
