package org.processmining.mixedparadigm.models.dfa.existence;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class ExactlyN extends GeneralDeterministicFiniteAutomaton {

	public ExactlyN(int alphabetSize, short label, short numberOfTimes) {
		super("Exactly " + numberOfTimes, alphabetSize, numberOfTimes + 1);

		addState(true, TV, true);
		for (short i = 0; i < numberOfTimes; i++) {
			addState(false, i == numberOfTimes - 1 ? TS : TV, true);
			addTransition(i, (short) (i + 1), label);
		}
		// cannot move with label from the final state
		removeTransition(numberOfTimes, label);

	}

}
