package org.processmining.mixedparadigm.models.dfa.existence;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

/**
 * General existence constraint for N occurences of the given label
 * 
 * @author bfvdonge
 * 
 */
public class ExistenceN extends GeneralDeterministicFiniteAutomaton {

	public ExistenceN(int alphabetSize, short label, short numberOfTimes) {
		super("Existence "+numberOfTimes,alphabetSize, numberOfTimes + 1);

		addState(true, TV, true);
		for (short i = 0; i < numberOfTimes; i++) {
			addState(false, i == numberOfTimes - 1 ? PS : TV, true);
			addTransition(i, (short) (i + 1), label);
		}

	}

}
