package org.processmining.mixedparadigm.models.dfa.negation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class NotChainSuccessionAB extends GeneralDeterministicFiniteAutomaton {

	public NotChainSuccessionAB(int alphabetSize, short transA, short transB) {
		super("Not Chain Succession",alphabetSize, 3);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, TS, false);
		short s2 = addState(false, TS, false);

		for (short l = 0; l < alphabetSize; l++) {
			addTransition(s1, s0, l);
			addTransition(s2, s0, l);
		}

		// add transA
		addTransition(s0, s1, transA);
		// remove transB in s1
		removeTransition(s1,  transB);
		// stay in s1 with transA
		addTransition(s1, s1, transA);

		// add transB
		addTransition(s0, s2, transB);
		// remove transA in s2
		removeTransition(s2,  transA);
		// stay in s2 with transB
		addTransition(s2, s2, transB);
	}

}
