package org.processmining.mixedparadigm.models.dfa.negation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class NotCoExistenceAB extends GeneralDeterministicFiniteAutomaton {

	public NotCoExistenceAB(int alphabetSize, short transA, short transB) {
		super("Not Co Existence",alphabetSize, 3);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, TS, true);
		short s2 = addState(false, TS, true);

		// add transA
		addTransition(s0, s1, transA);
		// remove transB in s1
		removeTransition(s1, transB);

		// add transB
		addTransition(s0, s2, transB);
		// remove transA in s2
		removeTransition(s2, transA);
	}

}
