package org.processmining.mixedparadigm.models.dfa.relation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class AlternatePrecedenceAB extends GeneralDeterministicFiniteAutomaton {

	public AlternatePrecedenceAB(int alphabetSize, short transA, short transB) {
		super("Alternate Precedence",alphabetSize, 2);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, TS, true);

		// add transA
		addTransition(s0, s1, transA);

		// add transB
		addTransition(s1, s0, transB);

		// remove transB in s0
		removeTransition(s0, transB);

	}

}
