package org.processmining.mixedparadigm.models.dfa.relation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class AlternateSuccessionAB extends GeneralDeterministicFiniteAutomaton {

	public AlternateSuccessionAB(int alphabetSize, short transA, short transB) {
		super("Alternate Succession", alphabetSize, 2);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, TV, true);

		// add transA
		addTransition(s0, s1, transA);

		// add transB
		addTransition(s1, s0, transB);

		// remove transB in s0
		removeTransition(s0, transB);
		// remove transA in s1
		removeTransition(s1, transA);

	}

}
