package org.processmining.mixedparadigm.models.dfa.relation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class ChainPrecedenceAB extends GeneralDeterministicFiniteAutomaton {

	public ChainPrecedenceAB(int alphabetSize, short transA, short transB) {
		super("Chain Precedence",alphabetSize, 2);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, TS, false);

		// add transA
		addTransition(s0, s1, transA);
		// remove transB in s0
		removeTransition(s0, transB);

		// add all except A from s1 to s0
		for (short i = 0; i < alphabetSize; i++) {
			addTransition(s1, s0, i);
		}
		// transA stays in s1
		addTransition(s1, s1, transA);
	}

}
