package org.processmining.mixedparadigm.models.dfa.relation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class ChainSuccessionAB extends GeneralDeterministicFiniteAutomaton {

	public ChainSuccessionAB(int alphabetSize, short transA, short transB) {
		super("Chain Succession", alphabetSize, 2);

		// add two state
		short s0 = addState(true, TS, true);
		// add two state
		short s1 = addState(false, TV, false);

		// from s0, go to s1 with A
		addTransition(s0, s1, transA);
		// B is not allowed in s0
		removeTransition(s0, transB);

		// in s1, only B is allowed to go back to s0
		addTransition(s1, s0, transB);

	}

}
