package org.processmining.mixedparadigm.models.dfa.relation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class CoExistenceAB extends GeneralDeterministicFiniteAutomaton {

	public CoExistenceAB(int alphabetSize, short transA, short transB) {
		super("Co Existence",alphabetSize, 4);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, TV, true);
		short s2 = addState(false, TV, true);
		short s3 = addState(false, PS, true);

		// add transA
		addTransition(s0, s1, transA);
		// add transB
		addTransition(s0, s2, transB);

		// add transB
		addTransition(s1, s3, transB);
		// add transA
		addTransition(s2, s3, transA);

	}

}
