package org.processmining.mixedparadigm.models.dfa.relation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class PrecedenceAB extends GeneralDeterministicFiniteAutomaton {

	public PrecedenceAB(int alphabetSize, short transA, short transB) {
		super("Precedence", alphabetSize, 2);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, PS, true);

		// add transA
		addTransition(s0, s1, transA);

		// remove transB in s0
		removeTransition(s0, transB);
	}

}
