package org.processmining.mixedparadigm.models.dfa.relation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

/**
 * Represents a responseAB constraint, i.e. after A, there has to be a B
 * 
 * @author bfvdonge
 * 
 */
public class ResponseAB extends GeneralDeterministicFiniteAutomaton {

	public ResponseAB(int alphabetSize, short transA, short transB) {
		super("Response", alphabetSize, 2);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, TV, true);

		// add transA
		addTransition(s0, s1, transA);

		// add transB
		addTransition(s1, s0, transB);
	}

}
