package org.processmining.mixedparadigm.models.dfa.relation;

import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;

public class SuccessionAB extends GeneralDeterministicFiniteAutomaton {

	public SuccessionAB(int alphabetSize, short transA, short transB) {
		super("Succession", alphabetSize, 3);

		// add two state
		short s0 = addState(true, TS, true);
		short s1 = addState(false, TV, true);
		short s2 = addState(false, TS, true);

		// add transA
		addTransition(s0, s1, transA);
		// remove transB in s0
		removeTransition(s0, transB);

		// add transB
		addTransition(s1, s2, transB);
		// add transA
		addTransition(s2, s1, transA);

	}

}