package org.processmining.mixedparadigm.models.mixedparadigm;

import java.util.Collection;

import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ConstraintType;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.models.graphbased.directed.petrinet.elements.ExpandableSubNet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public interface PetrinetWithAutomata extends PetrinetGraph {

	public abstract DeclarativeArc addConstraint(Transition from, Transition to, ConstraintType type);

	public abstract DeclarativeArc addConstraint(Transition from, Transition to, ConstraintType type,
			ExpandableSubNet parent);

	public abstract DeclarativeArc addConstraint(Transition from, ConstraintType.Unary type);

	public abstract DeclarativeArc addConstraint(Transition from, ConstraintType.Unary type, ExpandableSubNet parent);

	public abstract DeclarativeArc addConstraint(Collection<? extends Transition> from,
			Collection<? extends Transition> to, ConstraintType.Branched type);

	public abstract DeclarativeArc addConstraint(Collection<? extends Transition> from,
			Collection<? extends Transition> to, ConstraintType.Branched type, ExpandableSubNet parent);

	public abstract DeclarativeArc removeConstraint(DeclarativeArc arc);

	public abstract Collection<DeclarativeArc> getConstraints();

}
