package org.processmining.mixedparadigm.models.mixedparadigm.constraints.binary;

import gnu.trove.map.TObjectShortMap;

import org.processmining.mixedparadigm.models.dfa.DeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.dfa.relation.AlternatePrecedenceAB;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ActivationMode;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ConstraintType;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public final class AlternatePrecedence extends ConstraintType.Binary {

	public AlternatePrecedence() {
		super(ActivationMode.TARGETACTIVATED);
		graphics.setEndArrow(ArrowType.ARROW_TECHNICAL_CIRCLE);
		graphics.setNumberOfLines(2);
	}

	public DeterministicFiniteAutomaton getAutomaton(TObjectShortMap<Transition> trans2int, Transition from,
			Transition to) {
		return new AlternatePrecedenceAB(trans2int.size(), trans2int.get(from), trans2int.get(to));
	}

	public String getName() {
		return ALTERNATEPRECEDENCE;
	}
}