package org.processmining.mixedparadigm.models.mixedparadigm.constraints.branched;

import gnu.trove.map.TObjectShortMap;

import java.util.Collection;

import org.processmining.mixedparadigm.models.dfa.DeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ActivationMode;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ConstraintType;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class BranchedAlternatePrecedence extends ConstraintType.Branched {

	public BranchedAlternatePrecedence() {
		super(ActivationMode.TARGETACTIVATED);
		graphics.setEndArrow(ArrowType.ARROW_TECHNICAL_CIRCLE);
		graphics.setNumberOfLines(2);
	}

	public String getName() {
		return BRANCHEDALTERNATEPRECEDENCE;
	}

	public DeterministicFiniteAutomaton getAutomaton(TObjectShortMap<Transition> trans2int,
			Collection<? extends Transition> from, Collection<? extends Transition> to) {
		DeterministicFiniteAutomaton dfa = new GeneralDeterministicFiniteAutomaton(getName(), trans2int.size(), 2);

		// add two state
		short s0 = dfa.addState(true, DeterministicFiniteAutomaton.TS, true);
		short s1 = dfa.addState(false, DeterministicFiniteAutomaton.TS, true);

		for (Transition t : from) {
			// add transA
			dfa.addTransition(s0, s1, trans2int.get(t));
		}

		for (Transition t : to) {
			// add transB
			dfa.addTransition(s1, s0, trans2int.get(t));
			dfa.removeTransition(s0, trans2int.get(t));
		}

		return dfa;
	}
}