package org.processmining.mixedparadigm.models.mixedparadigm.constraints.branched;

import gnu.trove.map.TObjectShortMap;

import java.util.Collection;

import org.processmining.mixedparadigm.models.dfa.DeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ActivationMode;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ConstraintType;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class BranchedPrecedence extends ConstraintType.Branched {

	public BranchedPrecedence() {
		super(ActivationMode.TARGETACTIVATED);
		graphics.setStartArrow(ArrowType.ARROWTYPE_NONE);
		graphics.setEndArrow(ArrowType.ARROW_TECHNICAL_CIRCLE);
	}

	public DeterministicFiniteAutomaton getAutomaton(TObjectShortMap<Transition> trans2int,
			Collection<? extends Transition> from, Collection<? extends Transition> to) {
		DeterministicFiniteAutomaton dfa = new GeneralDeterministicFiniteAutomaton(getName(), trans2int.size());
		short s0 = dfa.addState(true, DeterministicFiniteAutomaton.TS, true);
		short s1 = dfa.addState(false, DeterministicFiniteAutomaton.PS, true);

		for (Transition t : from) {
			// transition from elements from s0 to s1
			dfa.addTransition(s0, s1, trans2int.get(t));
		}
		for (Transition t : to) {
			// remove "to" elements in s0
			dfa.removeTransition(s0, trans2int.get(t));
		}
		return dfa;
	}

	public String getName() {
		return BRANCHEDPRECEDENCE;
	}
}