package org.processmining.mixedparadigm.models.mixedparadigm.constraints.branched;

import gnu.trove.map.TObjectShortMap;

import java.util.Collection;

import org.processmining.mixedparadigm.models.dfa.DeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ActivationMode;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ConstraintType;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public final class BranchedRespondedExistence extends ConstraintType.Branched {

	public BranchedRespondedExistence() {
		super(ActivationMode.SOURCEACTIVATED);
		graphics.setStartArrow(ArrowType.ARROWTYPE_CIRCLE);
	}

	public String getName() {
		return BRANCHEDRESPONDEDEXISTENCE;
	}

	public DeterministicFiniteAutomaton getAutomaton(TObjectShortMap<Transition> trans2int,
			Collection<? extends Transition> from, Collection<? extends Transition> to) {
		DeterministicFiniteAutomaton dfa = new GeneralDeterministicFiniteAutomaton(getName(), trans2int.size(), 3);

		// add two state
		short s0 = dfa.addState(true, DeterministicFiniteAutomaton.TS, true);
		short s1 = dfa.addState(false, DeterministicFiniteAutomaton.TV, true);
		short s2 = dfa.addState(false, DeterministicFiniteAutomaton.PS, true);

		for (Transition t : from) {
			// add transA
			dfa.addTransition(s0, s1, trans2int.get(t));
		}

		for (Transition t : to) {
			// add transA
			dfa.addTransition(s1, s2, trans2int.get(t));
			dfa.addTransition(s0, s2, trans2int.get(t));
		}

		return dfa;
	}
}