package org.processmining.mixedparadigm.models.mixedparadigm.constraints.branched;

import gnu.trove.map.TObjectShortMap;

import java.util.Collection;

import org.processmining.mixedparadigm.models.dfa.DeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.dfa.GeneralDeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ActivationMode;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ConstraintType;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class BranchedResponse extends ConstraintType.Branched {

	public BranchedResponse() {
		super(ActivationMode.SOURCEACTIVATED);
		graphics.setStartArrow(ArrowType.ARROWTYPE_CIRCLE);
		graphics.setEndArrow(ArrowType.ARROWTYPE_TECHNICAL);
	}

	public DeterministicFiniteAutomaton getAutomaton(TObjectShortMap<Transition> trans2int,
			Collection<? extends Transition> from, Collection<? extends Transition> to) {
		DeterministicFiniteAutomaton dfa = new GeneralDeterministicFiniteAutomaton(getName(), trans2int.size());
		short s0 = dfa.addState(true, DeterministicFiniteAutomaton.TS, true);
		short s1 = dfa.addState(false, DeterministicFiniteAutomaton.TV, true);

		for (Transition t : from) {
			dfa.addTransition(s0, s1, trans2int.get(t));
		}
		for (Transition t : to) {
			dfa.addTransition(s1, s0, trans2int.get(t));
		}
		return dfa;
	}

	public String getName() {
		return BRANCHEDRESPONSE;
	}
}