package org.processmining.mixedparadigm.models.mixedparadigm.constraints.unary;

import gnu.trove.map.TObjectShortMap;

import org.processmining.mixedparadigm.models.dfa.DeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ConstraintType;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public final class AbsenceN extends ConstraintType.Unary {
	private short n;

	public AbsenceN(short n) {
		this.n = n;
	}

	public DeterministicFiniteAutomaton getAutomaton(TObjectShortMap<Transition> trans2int, Transition from) {
		return new org.processmining.mixedparadigm.models.dfa.existence.AbsenceN(trans2int.size(),
				trans2int.get(from), n);
	}

	public String getName() {
		return ATMOST_ + (n - 1);
	}
	
	public String getLabel() {
		return "[0.." + (n - 1) + "]";
	}

}