package org.processmining.mixedparadigm.models.mixedparadigm.constraints.unary;

import gnu.trove.map.TObjectShortMap;

import org.processmining.mixedparadigm.models.dfa.DeterministicFiniteAutomaton;
import org.processmining.mixedparadigm.models.mixedparadigm.constraints.ConstraintType;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public final class ExistenceN extends ConstraintType.Unary {
	private short n;

	public ExistenceN(short n) {
		this.n = n;
	}

	public DeterministicFiniteAutomaton getAutomaton(TObjectShortMap<Transition> trans2int, Transition from) {
		return new org.processmining.mixedparadigm.models.dfa.existence.ExistenceN(trans2int.size(),
				trans2int.get(from), n);
	}

	public String getName() {
		return ATLEAST_ + n;
	}

	public String getLabel() {
		return "[" + (n) + "..*]";
	}

}