package org.processmining.mixedparadigm.parameters;

import java.util.Collection;
import java.util.Map;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.mixedparadigm.models.mixedparadigm.DeclarativeArc;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.plugins.petrinet.replayer.algorithms.costbasedcomplete.CostBasedCompleteParam;

public class MPReplayParameters extends CostBasedCompleteParam {

	protected Map<DeclarativeArc, Integer> mapConstraint2Cost = null;
	private boolean allowViolatingConstraints;

	public MPReplayParameters(Collection<XEventClass> evClassCol, XEventClass dummyEvClass,
			Collection<Transition> transCol) {
		super(evClassCol, dummyEvClass, transCol);
	}

	public MPReplayParameters(Collection<XEventClass> evClassCol, XEventClass dummyEvClass,
			Collection<Transition> transCol, int defMoveOnModelCost, int defMoveOnLogCost) {
		super(evClassCol, dummyEvClass, transCol, defMoveOnModelCost, defMoveOnLogCost);
	}

	public MPReplayParameters(Map<XEventClass, Integer> mapEvClass2Cost, Map<Transition, Integer> mapTrans2Cost) {
		super(mapEvClass2Cost, mapTrans2Cost);
	}

	public MPReplayParameters(Map<XEventClass, Integer> mapEvClass2Cost, Map<Transition, Integer> mapTrans2Cost,
			Map<Transition, Integer> mapSync2Cost) {
		super(mapEvClass2Cost, mapTrans2Cost, mapSync2Cost);
	}

	public void setContraintCosts(Map<DeclarativeArc, Integer> mapConstraint2Cost) {
		this.mapConstraint2Cost = mapConstraint2Cost;

	}

	public Map<DeclarativeArc, Integer> getMapConstraint2Cost() {
		return this.mapConstraint2Cost;
	}

	public boolean isAllowViolatingConstraints() {
		return allowViolatingConstraints;
	}

	public void setAllowViolatingConstraints(boolean allowViolatingConstraints) {
		this.allowViolatingConstraints = allowViolatingConstraints;
	}
}
