package org.processmining.mixedparadigm.plugins;

import javax.swing.JComponent;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.mixedparadigm.algorithms.replayer.MPReplayResult;
import org.processmining.mixedparadigm.connections.MPReplayResultConnection;
import org.processmining.mixedparadigm.models.mixedparadigm.PetrinetWithAutomata;
import org.processmining.mixedparadigm.visualisation.MPReplayProjectedOnLogPanel;
import org.processmining.models.connections.petrinets.PNRepResultConnection;

/**
 * 
 * @author aadrians
 * @mail a.adriansyah@tue.nl
 * @since Dec 30, 2010
 */
@Plugin(name = "Project Alignment to Log", level = PluginLevel.NightlyBuild, //
returnLabels = { "Mixed Paradigm Log-Model Alignment Projected to Log" }, //
returnTypes = { JComponent.class }, parameterLabels = { "Mixed Paradigm Log-Model alignment" }, userAccessible = true)
@Visualizer
public class MPResultProjectedOnLogVisualizer {
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, MPReplayResult logReplayResult) {
		//System.gc();
		PetrinetWithAutomata net = null;
		XLog log = null;
		try {
			MPReplayResultConnection conn = context.getConnectionManager().getFirstConnection(
					MPReplayResultConnection.class, context, logReplayResult);

			net = conn.getObjectWithRole(PNRepResultConnection.PN);
			log = conn.getObjectWithRole(PNRepResultConnection.LOG);
		} catch (Exception exc) {
			context.log("No net can be found for this log replay result");
			return null;
		}

		return new MPReplayProjectedOnLogPanel(log, logReplayResult, context.getProgress());
	}
}