package org.processmining.mixedparadigm.plugins.pnml;

import org.processmining.models.connections.GraphLayoutConnection;
import org.processmining.models.graphbased.directed.petrinet.elements.ExpandableSubNet;
import org.processmining.models.jgraph.DirectedGraphNodeForMultiGraph;
import org.processmining.plugins.pnml.elements.graphics.PnmlNodeGraphics;

public class DPnmlMultiNodeGraphics extends PnmlNodeGraphics {

	/**
	 * PNML node graphics tag.
	 */
	public final static String TAG = "nodegraphics";

	protected DPnmlMultiNodeGraphics() {
		super(TAG);
	}

	public DPnmlMultiNodeGraphics convertFromNet(ExpandableSubNet parent, DirectedGraphNodeForMultiGraph element,
			GraphLayoutConnection layout) {
		DPnmlMultiNodeGraphics graphics = null;
		position = factory.createPnmlPosition().convertFromNet(parent, element, layout);
		fill = factory.createPnmlFill().convertFromNet(element);
		line = factory.createPnmlLine().convertFromNet(element);
		dimension = factory.createPnmlDimension().convertFromNet(element);
		if ((position != null) || (fill != null) || (line != null) || (dimension != null)) {
			graphics = this;
		}
		return graphics;
	}
}
